
//	Copyright 2010 Ohtan's Design Corporation

//	nokiaGlcdlib.c

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	006 2010.10.31
//	E{^֌W̕ύX
// ---------------------------------------------------------------------------
//	005 2010.10.31
//	EvO̐
// ---------------------------------------------------------------------------
//	004 2010.10.17
//	EPIC24FJ64GA002 RTCC ɂtA̕t
// ---------------------------------------------------------------------------
//	003 2010.10.13
//	Ezdl̕ύX Pʕ\̃LN^[ύXieϑf[^Pʂ܂߂ĂPsŕ\ł悤ɂj
// ---------------------------------------------------------------------------
//	002 2010.09.23
//	EC
// ---------------------------------------------------------------------------
//	001 2010.09.23
//	EVK쐬
//  Crated by A.Ohta
// ===========================================================================

// ***************************************************************************
//		mLA5110LCD쓮pCu[
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************
#include "p24FJ64GA002.h"

#include "_AtrDef24f.h"

#include "device.h"

#include "nokiaGlcdlib.h"											//  LCD

#include "rtcc.h"

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************

UINT LCD_MAX_PRES;
UINT LCD_MIN_PRES;

UINT LCD_MAX_TEMP;
UINT LCD_MIN_TEMP;

UINT LCD_MAX_RHUM;
UINT LCD_MIN_RHUM;

UH MemPres[48];															//  \pCf[^̋L̈
UH MemTemp[48];															//  \pxf[^̋L̈
int MemRhum[48];														//  \pxf[^̋L̈

// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************

/* uhPav */
unsigned char const font_hPa[] = 
{
	0b11111110,
	0b00001000,
	0b11111000,
	0b00000000,
	0b11111110,
	0b00010010,
	0b00001100,
	0b01000000,
	0b10101000,
	0b01110000,
};

/*  */
unsigned char const font_num[10][5]=
{
	{ /* 0 */
	0b01111100,
	0b10000010,
	0b10000010,
	0b10000010,
	0b01111100,
	},

	{ /* 1 */
	0b00000000,
	0b00000100,
	0b11111110,
	0b00000000,
	0b00000000,
	},

	{ /* 2 */
	0b11000100,
	0b10100010,
	0b10010010,
	0b10010010,
	0b10011100,
	},

	{ /* 3 */
	0b01000100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01111100,
	},

	{ /* 4 */
	0b00011000,
	0b00010100,
	0b00010010,
	0b11111110,
	0b00010000,
	},

	{ /* 5 */
	0b01011110,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01100010,
	},

	{ /* 6 */
	0b01111100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01100100,
	},

	{ /* 7 */
	0b00000010,
	0b00000010,
	0b11100010,
	0b00010010,
	0b00001110,
	},

	{ /* 8 */
	0b01101100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01101100,
	},

	{ /* 9 */
	0b00001100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01111100,
	},
};


/* mini */
unsigned char const font_mnum[10][3]=
{
	{ /* 0 */
	0b11111110,
	0b10000010,
	0b11111110,
	},

	{ /* 1 */
	0b00000100,
	0b11111110,
	0b00000000,
	},

	{ /* 2 */
	0b11110110,
	0b10010010,
	0b10011110,
	},

	{ /* 3 */
	0b10010010,
	0b10010010,
	0b11111110,
	},

	{ /* 4 */
	0b00011110,
	0b00010000,
	0b11111110,
	},

	{ /* 5 */
	0b10011110,
	0b10010010,
	0b11110010,
	},

	{ /* 6 */
	0b11111100,
	0b10010010,
	0b11110010,
	},

	{ /* 7 */
	0b00001110,
	0b00000010,
	0b11111110,
	},

	{ /* 8 */
	0b11111110,
	0b10010010,
	0b11111110,
	},

	{ /* 9 */
	0b00011110,
	0b00010010,
	0b11111110,
	},
};

/* miniu/v */
unsigned char const font_mslach[] = 
{
	0b00100000,
	0b00010000,
	0b00001000,
};

/* miniu:v */
unsigned char const font_mcolon[] = 
{
	0b00000000,
	0b01001000,
	0b00000000,
};

/* uv */
unsigned char const font_do[] = 
{
	0b00000000,
	0b00000010,
	0b01110101,
	0b10001010,
	0b10001000,
};

/* u{v */
unsigned char const font_plus[] =
{
	0b00010000,
	0b00010000,
	0b01111100,
	0b00010000,
	0b00010000,

};

/* u|v */
unsigned char const font_minus[] =
{
	0b00010000,
	0b00010000,
	0b00010000,
	0b00010000,
	0b00010000,
};

/* u.v */
unsigned char const font_period[] =
{
	0b00000000,
	0b11000000,
	0b11000000,
	0b00000000,
	0b00000000,
};


/* u%v */
unsigned char const font_percent[] =
{
	0b00000000,
	0b00100110,
	0b11010110,
	0b11001000,
	0b00000100,
};

/* uv */
unsigned char const font_square[] =
{
	0b11111111,
	0b11111111,
	0b11111111,
	0b11111111,
	0b11111111,
};

/* uSettingv */
unsigned char const font_setting[] =
{
	0b00100110,
	0b01001001,
	0b01001001,
	0b01001001,
	0b00110010,
	0b00000000,
	0b00000000,
	0b00111000,
	0b01010100,
	0b01010100,
	0b01011000,
	0b00000000,
	0b00000000,
	0b00000100,
	0b00111111,
	0b01000100,
	0b00000000,
	0b00000100,
	0b00111111,
	0b01000100,
	0b00000000,
	0b01111101,
	0b00000000,
	0b01111100,
	0b00000100,
	0b00000100,
	0b01111000,
	0b00000000,
	0b00000000,
	0b01101100,
	0b10110100,
	0b10101100,
	0b01000000,
	0b00000000,
};

/* uSleep!v */
unsigned char const font_Sleep[] =
{
	0b01001100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01100100,
	0b00000000,
	0b00000000,
	0b11111110,
	0b00000000,
	0b00000000,
	0b01111000,
	0b10010100,
	0b01011000,
	0b00000000,
	0b00000000,
	0b01111000,
	0b10010100,
	0b01011000,
	0b00000000,
	0b11111110,
	0b00010010,
	0b00001100,
	0b00000000,
	0b00000000,
	0b11011110,
	0b00000000,
	0b00000000,
	0b00000000,
	0b00000000,
	0b00000000,
	0b00000000,
	0b00000000,
	0b00000000,
	0b00000000,
};

/* uYv */
unsigned char const font_Y[] =
{
	0b00000010,
	0b00000100,
	0b11111000,
	0b00000100,
	0b00000010,
};

/* umv */
unsigned char const font_M[] =
{
	0b11111110,
	0b00000100,
	0b00011000,
	0b00000100,
	0b11111110,
};

/* uDv */
unsigned char const font_D[] =
{
	0b11111110,
	0b10000010,
	0b10000010,
	0b10000010,
	0b01111100,
};

/* uHv */
unsigned char const font_H[] =
{
	0b11111110,
	0b00010000,
	0b00010000,
	0b00010000,
	0b11111110,
};

/* uSv */
unsigned char const font_S[] =
{
	0b01001100,
	0b10010010,
	0b10010010,
	0b10010010,
	0b01100100,
};

/* u?v */
unsigned char const font_Question[] =
{
	0b00000100,
	0b00000010,
	0b10110010,
	0b00001100,
	0b00000000,
};

//============================================================================
//	mLA5110LCD۰Ư PCD8544 ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void LCD_init()
{
//  LCDݒ

	int i;

	SPI_RES = 0;														//  LCD Zbgw	֐Ăяo
	delay_us(10);														//  LCD Zbgێ
	SPI_RES = 1;														//  LCD Zbg	֐Ăяo

	SPI_DC = 0;															//	֐Ăяoă|[gkB̏o͒[q͕⏞
	SPI_SCE = 0;														//  LCD `bvCl[u
	SPI_CLK = 0;														//  ݒ

	SPI_tx_byte(0b00100000 | 1, 0);										//  H = 1
	SPI_tx_byte(0b00000100 | 1, 0);										//  TC = 1 (0-3)
	SPI_tx_byte(0b00010000 | 3, 0);										//  Bais = 3 (0-7)
	SPI_tx_byte(0b10000000 | 68, 0);									//  Vop = 68 (0-127) RgXgݒ
	SPI_tx_byte(0b00100000 | 0, 0);										//  H = 0, Horizontal addressing
	SPI_tx_byte(0b00001000 | 4, 0);										//  Display Mode Normal = 4
	SPI_tx_byte(0b01000000 | 0, 0);										//  Set Y = 0 (0-5)
	SPI_tx_byte(0b10000000 | 0, 0);										//  Set X = 0 (0-83)

	for (i = 0;i<48;i++) {												//  MemPres[]ōlȏŃNA
		MemPres[i] = 2000;
	}

	for (i = 0;i<48;i++) {												//  MemTemp[]ōlȏŃNA
		MemTemp[i] = 60;
	}

	for (i = 0;i<48;i++) {												//  MemTemp[]ōlȏŃNA
		MemRhum[i] = 110;
	}

	LCD_MAX_PRES = intLCD_MAX_PRES;										//  vbgłC̍őlݒ肷
	LCD_MIN_PRES = intLCD_MIN_PRES;										//  vbgłC̍ŏlݒ肷

	LCD_MAX_TEMP = intLCD_MAX_TEMP;										//  vbgłC̍őlݒ肷
	LCD_MIN_TEMP = intLCD_MIN_TEMP;										//  vbgłC̍ŏlݒ肷

	LCD_MAX_RHUM = intLCD_MAX_RHUM;										//  vbgł鎼x̍őlݒ肷
	LCD_MIN_RHUM = intLCD_MIN_RHUM;										//  vbgł鎼x̍ŏlݒ肷

}


//============================================================================
//	LCD݈̏ʒu@wAx@ɐݒ肷
//----------------------------------------------------------------------------
//	́F	unsigned char x,unsigned char y
//	óF	
//----------------------------------------------------------------------------
//	lF	0 <= x <= 83, 0 <= y <= 5
//  		 y ͉Eォ牺@LSBŏl̂WrbgP
//  		mLALCD̃Ot́Aオ_B
//============================================================================
void LCD_locate(unsigned char x,unsigned char y)
{
	SPI_tx_byte(0b01000000 | y, 0);										//  Set Y = y
	SPI_tx_byte(0b10000000 | x, 0);										//  Set X = x
}

//============================================================================
//	݂݈̏ʒuwoCg̃f[^
//----------------------------------------------------------------------------
//	́F	unsigned char *datap,int len
//	óF	
//----------------------------------------------------------------------------
//	lF	̃R}hlen̉񐔕xʒu𑝂₵Ȃ牡ւPoNw肳ꂽoCgf[^
//============================================================================
void LCD_set_data(unsigned char *datap,int len)
{
	for (;len>0;len--)
		SPI_tx_byte(*(datap++), 1);
}

//============================================================================
//	݂݈̏ʒuwoCg̕\NA
//----------------------------------------------------------------------------
//	́F	unsigned int len
//	óF	
//----------------------------------------------------------------------------
//	lF	̃R}hlen̉񐔕xʒu𑝂₵Ȃ牡ւPoNNA
//============================================================================
void LCD_clear(unsigned int len)
{
	for (;len>0;len--)
		SPI_tx_byte(0, 1);
}

//============================================================================
//	Data/Command@w肵āALCDɂPoCg𑗐M
//----------------------------------------------------------------------------
//	́F	unsigned char d,int dc
//	óF	
//----------------------------------------------------------------------------
//	lF	dc = 0 : Command, dc = 1 : Data
//============================================================================
void SPI_tx_byte(unsigned char d,int dc)
{
	char Loop;
 

	SPI_SCE = 0;

	SPI_DC = 0;
	if (dc) {
		SPI_DC = 1;
	}

	for (Loop=0;Loop<8;Loop++){
		SPI_DATA = 0;
		if ((d & (unsigned char)0x80) != 0){
			SPI_DATA = 1;
		}
		delay_us(3);
		SPI_CLK = 1;
		d <<= 1;
		delay_us(6);
		SPI_CLK = 0;
	}
	SPI_SCE = 1;
}

//============================================================================
//	Pʂňʒuw肵Đ̐\(F5dotp)
//----------------------------------------------------------------------------
//	́F	int n: int col(end position of clom), int y_bank
//	óF	
//----------------------------------------------------------------------------
//	lF	col :
//============================================================================
void print_num(int n, int col, int y_bank)
{
	int r;
	unsigned char *pc;

	do {
		r = n % 10;														//  1ԉ̌̒lvZ
		n = n / 10;
		LCD_locate(col*6, y_bank);										//  \ʒuvZ
		pc = (unsigned char *)(font_num[r]);
		LCD_set_data(pc, 5);											//  1ԉ̌̒lɑΉ镶\
		--col;
	} while (n > 0);													//  SĂ̌\܂ŌJԂ
}

//============================================================================
//	Pʂňʒuw肵Đ̐\(F3dotp)
//----------------------------------------------------------------------------
//	́F	int n: int col(end position of clom), int y_bank
//	óF	
//----------------------------------------------------------------------------
//	lF	col :
//============================================================================
void print_mnum(int n, int col, int y_bank)
{
	int r;
	unsigned char *pc;

	do {
		r = n % 10;														//  1ԉ̌̒lvZ
		n = n / 10;
		LCD_locate(col*4, y_bank);										//  \ʒuvZ
		pc = (unsigned char *)(font_mnum[r]);
		LCD_set_data(pc, 3);											//  1ԉ̌̒lɑΉ镶\
		--col;
	} while (n > 0);													//  SĂ̌\܂ŌJԂ
}

//============================================================================
//	C̒P hPa \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_unithps()
{
	unsigned char *pc;

	/* uhPav\ */
	LCD_locate(24, 3);
	pc = (unsigned char *)font_hPa;
	LCD_set_data(pc, 10);
}

//============================================================================
//	x̒P  \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_unitdeg()
{
	unsigned char *pc;

	/* uv\ */
	LCD_locate(29, 4);
	pc = (unsigned char *)font_do;
	LCD_set_data(pc, 5);
}

//============================================================================
//	Ύx̒P % \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_percent()
{
	unsigned char *pc;

	/* u%v\ */
	LCD_locate(29, 5);													// x\̒̈ʒu  
	pc = (unsigned char *)font_percent;
	LCD_set_data(pc, 5);
}

//============================================================================
//	uSettingv \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_setting()
{
	unsigned char *pc;

	/* uv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_setting;
	LCD_set_data(pc, 34);
}

//============================================================================
//	uYv \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_Y()
{
	unsigned char *pc;

	/* uYv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_Y;
	LCD_set_data(pc, 5);
}

//============================================================================
//	uMv \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_M()
{
	unsigned char *pc;

	/* uMv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_M;
	LCD_set_data(pc, 5);
}

//============================================================================
//	uDv \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_D()
{
	unsigned char *pc;

	/* uDv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_D;
	LCD_set_data(pc, 5);
}

//============================================================================
//	uHv \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_H()
{
	unsigned char *pc;

	/* uHv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_H;
	LCD_set_data(pc, 5);
}

//============================================================================
//	uSv \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_S()
{
	unsigned char *pc;

	/* uSv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_S;
	LCD_set_data(pc, 5);
}

//============================================================================
//	u?v \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_Question()
{
	unsigned char *pc;

	/* u?v\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_Question;
	LCD_set_data(pc, 5);
}

//============================================================================
//	uSleep!v \
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_Sleep()
{
	unsigned char *pc;

	/* uv\ */
	LCD_locate(0, 2);
	pc = (unsigned char *)font_Sleep;
	LCD_set_data(pc, 34);
}

//============================================================================
//	mLA5110LCD́@(x, y)sNZWɓ_`悷B
//----------------------------------------------------------------------------
//	́F	int x, int y
//	óF	
//----------------------------------------------------------------------------
//	lF	ÝAŏA㑤őimLALCDY𔽓]ĕ\jB
//			0 <= x <= 83 , 0 <= y <= 47 őnAŏl𒴂Ăꍇ́A͈͓ 
//			NvB 
//============================================================================
void draw_point(int x, int y)
{
	int bank_y;
	unsigned char pat_y;

	if (y < 0) {
		bank_y = LCD_MAX_BANK;											//  Y̒lȂ΁AOt̍ŏlɃNvăvbgB
		pat_y = 0b10000000;												//  LCD̍ő呤ij𐔒l̍ŏƂ邽߁AMSBŏlB
	} else if (y > LCD_MAX_Y) {
		bank_y = 0;														//  Y̒lől𒴂ĂȂ΁AOőlɃNvăvbgB
		pat_y = 0b00000001;												//  LCD̍ŏi㑤j𐔒l̍őƂ邽߁ALSBőlB
	} else {
		bank_y = LCD_MAX_BANK - (y / 8);								//  y]ʒuɃoN
		pat_y = 0b10000000 >> (y % 8);									//  oNMSBŏlƂ邱ƂY\0ƂȂ
	}
	LCD_locate(x, bank_y);												//  xʒũoN
	LCD_set_data(&pat_y, 1);											//  oN8rbgp^[

}

//============================================================================
//	(x, y)sNZWɋC`
//----------------------------------------------------------------------------
//	́F	int x, int prsy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Prespoint(int x, int prsy)
{

	int bank_prsy;
	unsigned char pat_prsy;
															//  OtԂ̏A͈͓ɒlNvB

	if (prsy < 32 ) {										//  ClCOtԂ̍ŏ͈͂H
		bank_prsy = 1;
		pat_prsy = 0b10000000;
	}
	else if (prsy > 47 ) {									//  ClCOtԂ̍ő͈͂オH
		bank_prsy = 0;
		pat_prsy = 0b00000001;
	}
	else {
		bank_prsy = LCD_MAX_BANK - (prsy / 8);				//  \oNvZ
		pat_prsy = 0b10000000 >> (prsy % 8);				//  oÑrbgʒuvZ
	}
	LCD_locate(x, bank_prsy);								//  xʒuŃoN(C)
	LCD_set_data(&pat_prsy, 1);								//  oN֋C8rbgp^[
}

//============================================================================
//	(x, y)sNZWɋC`
//----------------------------------------------------------------------------
//	́F	int x, int degy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Temppoint(int x, int tempy)
{

	int bank_tempy;
	unsigned char pat_tempy;
															//  OtԂ̏A͈͓ɒlNvB

	if (tempy < 16 ) {										//  ClCOtԂ̍ŏ͈͂H
		bank_tempy = 3;
		pat_tempy = 0b10000000;
	}
	else if (tempy > 31 ) {									// @ClCOtԂ̍ő͈͂オH
		bank_tempy = 2;
		pat_tempy = 0b00000001;
	}
	else {
		bank_tempy = LCD_MAX_BANK - (tempy / 8);			//  \oNvZ
		pat_tempy = 0b10000000 >> (tempy % 8);				//  oÑrbgʒuvZ
	}
	LCD_locate(x, bank_tempy);								//  xʒuŃoN(C)
	LCD_set_data(&pat_tempy, 1);							//  oN֋C8rbgp^[
}

//============================================================================
//	(x, y)sNZWɎx`
//----------------------------------------------------------------------------
//	́F	int x, int rhy
//	óF	
//----------------------------------------------------------------------------
//	lF	\
//============================================================================
void draw_Rhumpoint(int x, int rhy)
{

	int bank_rhy;
	unsigned char pat_rhy;
															//  OtԂ̏A͈͓ɒlNvB

	if (rhy < 0 ) {											//  xlxOtԂ̍ŏ͈͂H
		bank_rhy = 5;
		pat_rhy = 0b10000000;
	}
	else if (rhy > 15 ) {									// @xlxOtԂ̍ő͈͂オH
		bank_rhy = 4;
		pat_rhy = 0b00000001;
	}
	else {
		bank_rhy = LCD_MAX_BANK - (rhy / 8);				//  \oNvZ
		pat_rhy = 0b10000000 >> (rhy % 8);					//  oÑrbgʒuvZ

	}
		LCD_locate(x, bank_rhy);							//  xʒuŃoN(x)
		LCD_set_data(&pat_rhy, 1);							//  oNx8rbgp^[
}

//============================================================================
//	OtY\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_Yaxis()
{
	int	x, y;
	unsigned char c;

	c = 0b10101010;
	x = LCD_MAX_X - GRAPH_HIST_MAX;

	//* c\

	for (y = 0; y < 6; y++) {
		LCD_locate(x, y);
		LCD_set_data(&c, 1);
	}

	//* Y݂̍\
	for (y = 0; y <= LCD_MAX_Y; y += 16) {
		draw_point(x - 1, y);
	}
}

//============================================================================
//	Plot X ʒűCOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Presclear(int plotx)
{
	int	i;

	for (i=0;i<2;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(1);
		if (plotx < 46){
			LCD_clear(1);
		}
		if (plotx < 47){
			LCD_clear(1);
		}
	}
}


//============================================================================
//	Plot X ʒűCOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Tempclear(int plotx)
{
	int	i;

	for (i=2;i<4;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(1);
		if (plotx < 46){
			LCD_clear(1);
		}
		if (plotx < 47){
			LCD_clear(1);
		}
	}
}


//============================================================================
//	Plot X ʒu̎xOtc݂̈̂NA
//----------------------------------------------------------------------------
//	́F	int plotx
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void graph_plotx_Rhumclear(int plotx)
{
	int	i;

	for (i=4;i<6;i++){
		LCD_locate(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1 ,i);
		LCD_clear(1);
		if (plotx < 46){
			LCD_clear(1);
		}
		if (plotx < 47){
			LCD_clear(1);
		}
	}
}



//============================================================================
//	C𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_press(int pdata)
{
	/*@\̈NA */
	LCD_locate(0,3);
	LCD_clear(4 * 6);

	print_num(pdata,3,3);
}


//============================================================================
//	x𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_temp(int tempA, int temp_sign)
{
	int col;
	unsigned char *pc;

	/*@\̈NA */
	LCD_locate(0,4);
	LCD_clear(5 * 6);

	/* \ */
	LCD_locate(0, 4);
	if (temp_sign != 0) {
		pc = (unsigned char *)font_minus;
	} else {
		pc = (unsigned char *)font_plus;
	}
	LCD_set_data(pc, 5);

	/* x̐l\ij */
	print_num(tempA/10, 2, 4);

	/* _\@*/
	col = 3;
	LCD_locate(col*6, 4);
	pc = (unsigned char *)font_period;
	LCD_set_data(pc, 5);

	/* x̐l\ij */
	tempA = tempA % 10;
	print_num(tempA, 4, 4);

}

//============================================================================
//	Ύx𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_RH(int RHA)
{
	unsigned char *pc;

	/*@\̈NA */
	LCD_locate(0,5);
	LCD_clear(5 * 6);

	/* x̐l\ij */
	print_num(RHA/10, 2, 5);

	/* _\@*/
	LCD_locate(18, 5);
	pc = (unsigned char *)font_period;
	LCD_set_data(pc, 5);

	/* x̐l\ij */
	RHA = RHA % 10;
	print_num(RHA, 4, 5);

}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotPres(int gX, UW Pres)
{
	int i;
	UH	Value;
	Value = (UH)(Pres / 400L);											//	ʏ300 `1200͈͓̔̂͂
	MemPres[gX] = Value;												//  Cf[^̗cB
 
	if (Value > LCD_MAX_PRES ) {										//  \̍ől𒴂H
		LCD_MAX_PRES = Value;											//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_PRES = LCD_MAX_PRES - 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Presgraph(i, MemPres[i] );							//  C̗V臒lŃvbg
		}
	}
	else if (Value < LCD_MIN_PRES ) {									//  \̍ŏlH
		LCD_MIN_PRES = Value;											//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_PRES = LCD_MIN_PRES + 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Presgraph(i, MemPres[i] );							//  C̗V臒lŃvbg
		}
	}
	print_Presgraph(gX, Value);											//  ݂̋Cvbg
}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotTemp(int gX, UH Temp)
{
	int i;
	if (Temp & (UH)BIT15) {												//	}CiXwH
		Temp = (~Temp) + 1;												//	ΒlZo
	}
	MemTemp[gX] = Temp/20;												//  Cf[^̗cB
 
	if (Temp/20 > LCD_MAX_TEMP ) {										//  \̍ől𒴂H
		LCD_MAX_TEMP = Temp/20;											//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_TEMP = LCD_MAX_TEMP - 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Tempgraph(i, MemTemp[i] );							//  C̗V臒lŃvbg
		}
	}
	else if (Temp/20 < LCD_MIN_TEMP ) {									//  \̍ŏlH
		LCD_MIN_TEMP = Temp/20;											//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_TEMP = LCD_MIN_TEMP + 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Tempgraph(i, MemTemp[i] );							//  C̗V臒lŃvbg
		}
	}
	print_Tempgraph(gX, (int)Temp/20);									//  Cvbg																	
}

//============================================================================
//	xf[^Plot							
//----------------------------------------------------------------------------
//	́F	xf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotRhum(int gX, UH vRhum)
{
	int i;

	MemRhum[gX] = vRhum/10;												//  Cf[^̗cB
 
	if (vRhum/10 > LCD_MAX_RHUM ) {										//  \̍ől𒴂H
		LCD_MAX_RHUM = vRhum/10;											//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_RHUM = LCD_MAX_RHUM - 31 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Rhumgraph(i, MemRhum[i] );							//  C̗V臒lŃvbg
		}
	}
	else if (vRhum/10 < LCD_MIN_RHUM ) {									//  \̍ŏlH
		LCD_MIN_RHUM = vRhum/10;											//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_RHUM = LCD_MIN_RHUM + 31 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Rhumgraph(i, MemRhum[i] );							//  C̗V臒lŃvbg
		}
	}
	print_Rhumgraph(gX, vRhum/10);										//  xvbg																	
}

//============================================================================
//	mLA5110LCD֋Cf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int pdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//============================================================================
void print_Presgraph(int plotx, unsigned short pdata)
{
	int	 pgraphy;

	if (pdata < 1200 && pdata > 300) {

		graph_plotx_Presclear(plotx);

		pgraphy = pdata - LCD_MIN_PRES + 32;

		draw_Prespoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, pgraphy);

	}
}

//============================================================================
//	mLA5110LCD։xf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int tdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p
//============================================================================
void print_Tempgraph(int plotx, int tdata)
{
	int	 tgraphy;

	if (tdata < 51 && tdata > -20) {

		graph_plotx_Tempclear(plotx);

		tgraphy = tdata - LCD_MIN_TEMP + 16;

		draw_Temppoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, tgraphy);
	}

}

//============================================================================
//	mLA5110LCD֎xf[^Ot\`悷ׂɃOtԂɕϊB
//----------------------------------------------------------------------------
//	́F	int plotx, int rhdata
//	óF	
//----------------------------------------------------------------------------
//	lF	\p 2%/dot
//============================================================================
void print_Rhumgraph(int plotx, int rhdata)
{
	int	 rhgraphy;

	if (rhdata < 101 && rhdata >= 0 ) {

		graph_plotx_Rhumclear(plotx);

		rhgraphy = (rhdata - LCD_MIN_RHUM)/2;

		draw_Rhumpoint(LCD_MAX_X - GRAPH_HIST_MAX + plotx + 1, rhgraphy);
	}
}

//============================================================================
//	t𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_rtccdate(int rtccYearH, int rtccYearL, int rtccMonthH, int rtccMonthL, int rtccDayH, int rtccDayL)
{
	int col;
	unsigned char *pc;

	//@\̈NA
	LCD_locate(0,0);
	LCD_clear(8 * 4);

	print_mnum(rtccYearH,0,0);
	print_mnum(rtccYearL,1,0);

	// mini slach \
	col = 2;
	LCD_locate(col*4, 0);
	pc = (unsigned char *)font_mslach;
	LCD_set_data(pc, 3);

	print_mnum(rtccMonthH,3,0);
	print_mnum(rtccMonthL,4,0);

	// mini slach \
	col = 5;
	LCD_locate(col*4, 0);
	pc = (unsigned char *)font_mslach;
	LCD_set_data(pc, 3);

	print_mnum(rtccDayH,6,0);
	print_mnum(rtccDayL,7,0);

}

//============================================================================
//	𐔒l\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void print_rtcctime(int rtccHourH, int rtccHourL, int rtccMinH, int rtccMinL, int rtccSecH, int rtccSecL)
{
	int col;
	unsigned char *pc;

	//@\̈NA
	LCD_locate(0,1);
	LCD_clear(8 * 4);

	print_mnum(rtccHourH,0,1);
	print_mnum(rtccHourL,1,1);

	// mini slach \
	col = 2;
	LCD_locate(col*4, 1);
	pc = (unsigned char *)font_mcolon;
	LCD_set_data(pc, 3);

	print_mnum(rtccMinH,3,1);
	print_mnum(rtccMinL,4,1);

	// mini slach \
	col = 5;
	LCD_locate(col*4, 1);
	pc = (unsigned char *)font_mcolon;
	LCD_set_data(pc, 3);

	print_mnum(rtccSecH,6,1);
	print_mnum(rtccSecL,7,1);

}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************
