
//	Copyright 2010 Ohtan's Design Corporation

//	*     * okiaGlcdlib.h
//	**    *
//	* *   *
//	*  *  *
//	*   * *
//	*    **
//	*     *

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	004 2010.10.31
//	EvO̐ by A.Ohta
// ---------------------------------------------------------------------------
//	003 2010.10.13
//	Ezdl̕ύX
// ---------------------------------------------------------------------------
//	004 2010.09.30
//	Ezdl@RgC
// ---------------------------------------------------------------------------
//	003 2010.09.3
//	ECf[^EEPROMɋL^
// ---------------------------------------------------------------------------
//	002 2010.08.20
//	EI/O_̏C
// ---------------------------------------------------------------------------
//	001 2010.06.26
//	EVK쐬
//  Crated by A.Ohta
// ===========================================================================

#ifndef	_INC_NOKIAGLCDLIB
#define	_INC_NOKIAGLCDLIB

// ***************************************************************************
//		mLA5110LCD쓮pCu[wb_[t@C
// ***************************************************************************

// ***************************************************************************
// *	zdl																 *
// ***************************************************************************
/*
	NOKIA 5110 LCD ]TvvO	PIC24FJ64GA002  CLOCK:8MHz Vdd = 3.3V

	RA0:
	RA1:
	RA2:
	RA3:
	RA4:

	RB0:
	RB1:
	RB2:
	RB3:
	RB4:
	RB5:
	RB6:
	RB7:

	RB8:
	RB9:
	RB10:(INV)RES	PIC -> GLCD		(INV)Zbg
	RB11:D/C		PIC -> GLCD		f[^/R}hIM
	RB12:SLCK		PIC -> GLCD		NbN
	RB13:SDIN		PIC -> GLCD		f[^

	RB14:RTCC		igpj			1Hz Clock out/Alarm

	RB15:(INV)SCE	PIC -> GLCD		(INV)`bvZNg

	EOtBbNLCDƂ̒ʐMC^tF[X͐prohʐMB

*/

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

	// 48~84hbgOtBbNLCD@|[g`
					
#define SPI_SCE			LATBbits.LATB15
#define SPI_DATA		LATBbits.LATB13
#define SPI_CLK			LATBbits.LATB12
#define SPI_DC			LATBbits.LATB11
#define SPI_RES			LATBbits.LATB10

#define LCD_WIDTH		84
#define LCD_HEIGHT		48
#define LCD_BANKS		(LCD_HEIGHT/8)
#define LCD_MAX_X		(LCD_WIDTH  - 1)
#define LCD_MAX_Y		(LCD_HEIGHT - 1)
#define LCD_MAX_BANK	(LCD_BANKS - 1)

#define GRAPH_HIST_MAX	48

																		//  POPRhPa1hPa/dot
#define intLCD_MAX_PRES	1021											//  \C̍ől̏l
#define intLCD_MIN_PRES	1006											//  \C̍ŏl̏l

																		//  25xb1x/dot
#define intLCD_MAX_TEMP	33												//  \鉷x̍ől̏l
#define intLCD_MIN_TEMP	18												//  \鉷x̍ŏl̏l

																		//  50%2%/dot
#define intLCD_MAX_RHUM	66												//  \鎼x̍ől̏l
#define intLCD_MIN_RHUM	35												//  \鎼x̍ŏl̏l

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************

// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

void SPI_tx_byte(unsigned char, int);
void SPI_tx_data(unsigned char);
void SPI_tx_command(unsigned char);

void LCD_init();
void LCD_locate(unsigned char, unsigned char);
void LCD_set_data(unsigned char *, int);
void LCD_clear(unsigned int);

void print_num(int, int, int);
void print_mnum(int, int, int);

void print_unithps(void);
void print_percent(void);
void print_unitdeg(void);
void print_setting(void);
void print_Y(void);
void print_M(void);
void print_D(void);
void print_H(void);
void print_S(void);
void print_Question(void);
void print_Sleep(void);

void print_Yaxis(void);

void print_rtccdate(int,int,int,int,int,int);
void print_rtcctime(int,int,int,int,int,int);

void MngplotPres(int,UW);
void MngplotTemp(int,UH);
void MngplotRhum(int,UH);

void graph_plotx_Presclear(int);
void graph_plotx_Tempclear(int);
void graph_plotx_Rhumclear(int);
void print_press(int);
void print_temp(int, int);
void print_RH(int);
void print_Presgraph(int, unsigned short);
void print_Tempgraph(int, int);
void print_Rhumgraph(int, int);
void draw_point(int, int);
void draw_Prespoint(int, int);
void draw_Temppoint(int, int);
void draw_Rhumpoint(int, int);

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

#endif

//	Copyright 2010 Ohtan's Design Corporation

